unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Clipbrd, Buttons, ExtCtrls,  Menus, DlgShowHdaIntf,
  Dialogs, ComCtrls, StdCtrls,dOPCDlgServerSelect,
  Variants,  dOPCIntf, dOPCComn, dOPCHDA, dOPCHDADlgBrowse,dOPCDlgServerStatus;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    ListView1: TListView;
    Label1: TLabel;
    eItemId: TEdit;
    bSelectItem: TSpeedButton;
    Label3: TLabel;
    eFromDate: TDateTimePicker;
    eFromTime: TDateTimePicker;
    Label4: TLabel;
    eToTime: TDateTimePicker;
    eToDate: TDateTimePicker;
    bShowHistory: TButton;
    Label9: TLabel;
    cAsync: TCheckBox;
    PopupMenu1: TPopupMenu;
    Now1: TMenuItem;
    Now30min1: TMenuItem;
    Now60min1: TMenuItem;
    PageReadMethod: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    Label7: TLabel;
    cAggregate: TComboBox;
    Label6: TLabel;
    eResampleInterval: TEdit;
    Label11: TLabel;
    eRequestedValues: TEdit;
    Label13: TLabel;
    cBounded: TCheckBox;
    PopupMenu2: TPopupMenu;
    SetStartEndtime1: TMenuItem;
    Starttimefromselected1: TMenuItem;
    Endtimefromselected1: TMenuItem;
    Label14: TLabel;
    eMaxValues: TEdit;
    TimeMemo: TMemo;
    CopyTimeStamptoClipboard1: TMenuItem;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    SelectServer1: TMenuItem;
    Disconnect1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    ServerStatus1: TMenuItem;
    N2: TMenuItem;
    OPCServer: TdOPCHDAServer;
    Panel3: TPanel;
    Panel2: TPanel;
    Label10: TLabel;
    Label12: TLabel;
    LReturnedValues: TLabel;
    LMaxPossible: TLabel;
    StatusMemo: TMemo;
    Splitter1: TSplitter;
    ServerInterfaces1: TMenuItem;
    procedure FormShow(Sender: TObject);
    procedure bShowHistoryClick(Sender: TObject);
    procedure bSelectItemClick(Sender: TObject);
    procedure OPCServerDisconnect(Sender: TObject);
    procedure OPCServerConnect(Sender: TObject);
    procedure Now1Click(Sender: TObject);
    procedure Now30min1Click(Sender: TObject);
    procedure Now60min1Click(Sender: TObject);
    procedure SetStartEndtime1Click(Sender: TObject);
    procedure Starttimefromselected1Click(Sender: TObject);
    procedure Endtimefromselected1Click(Sender: TObject);
    procedure CopyTimeStamptoClipboard1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure SelectServer1Click(Sender: TObject);
    procedure Connect1Click(Sender: TObject);
    procedure Disconnect1Click(Sender: TObject);
    procedure OPCServerServerShutdown(Sender: TObject; Reason: String);
    function OPCServerReadComplete(Status: HRESULT;
      hdaItems: TdOPCHDAItems; UserData: Cardinal;
      EventType: TdOPCHDAEventType): HRESULT;
    procedure ServerStatus1Click(Sender: TObject);
    procedure TabSheet4Show(Sender: TObject);
    procedure TabSheet4Hide(Sender: TObject);
    procedure ServerInterfaces1Click(Sender: TObject);
  private
    function  GetEndTime: TDateTime;
    function  GetStartTime: TDateTime;
    procedure Clear;
    procedure ShowDataValues(Item: TdOPCHDAItem);
    function  GetAggregateId: integer;
    procedure SetTime(min: integer);
    procedure ReadRaw(Items : TdOPCHdaItems);
    procedure ReadProcessed(Items : TdOPCHdaItems);
    procedure ReadModified(Items : TdOPCHdaItems);
    procedure SetTimeEdit(DObj,TObj : TDateTimePicker; index :integer);
    procedure ReadAtTime(Items: TdOPCHdaItems);
    function CheckServer: boolean;
    procedure EnableDates(enable: boolean);
    function ListItemIndex: Integer;
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormShow(Sender: TObject);
begin
  Clear;
  PageReadMethod.ActivePageIndex := 0;
end;

procedure TForm1.Clear;
begin
  eItemId.Text     := '';
  eFromDate.Date   := EncodeDate(2000,1,1);
  eFromDate.Time   := 0;
  eFromTime.Time   := EncodeTime(0,0,0,1);
  eToTime.Time     := EncodeTime(0,0,0,1);
  eToDate.Date     := EncodeDate(2020,1,1);;
  eToDate.Time     := 0;

  Listview1.Items.Clear;
  LMaxPossible.Caption := '-';
  LReturnedValues.Caption  := '-';
  cAggregate.Clear;
end;

function TForm1.GetStartTime: TDateTime;
begin
  result := eFromDate.Date + eFromTime.Time;
end;

function TForm1.GetEndTime: TDateTime;
begin
  result   := eToDate.Date + eToTime.Time;
end;

procedure TForm1.ShowDataValues(Item: TdOPCHDAItem);
var
  i : integer;
  ListItem  : TListItem;
  ItemValue : TdOPCHDAValueItem;
begin
  Listview1.Items.BeginUpdate;
  try
    Listview1.Items.Clear;
    for i := 0 to Item.Values.Count-1 do
    begin
      ItemValue := Item.Values[i];
      ListItem := Listview1.Items.Add;
      ListItem.Caption := DateTimeToStr(ItemValue.TimeStamp);
      ListItem.SubItems.Add(VarToStr(ItemValue.Value));
      ListItem.SubItems.Add(QualitytoStr(ItemValue.Quality));
      ListItem.SubItems.Add(ItemValue.HdaQualityAsString);
    end;
    LReturnedValues.Caption  := IntToStr(Item.Values.Count);
    StatusMemo.Lines.Add(format('%d items values loaded',[Item.Values.Count]));
  finally
   Listview1.Items.EndUpdate;
  end;
end;


function TForm1.GetAggregateId: integer;
var
  Aggregate : TdOPCHDAAggregatesItem;
begin
  result := 0; // 0 = no Aggregate
  if cAggregate.Items.Count > 0 then
  begin
    result := cAggregate.ItemIndex;
    if result >= 0 then
    begin
      Aggregate :=  TdOPCHdaAggregatesItem( cAggregate.Items.Objects[cAggregate.ItemIndex]);
      result := Aggregate.ID;
    end;
  end;
end;


procedure TForm1.ReadRaw(Items : TdOPCHdaItems);
begin
  if cAsync.Checked then
    Items.AsyncReadRaw(GetStartTime,GetEndTime,StrToInt(eRequestedValues.Text),cBounded.Checked,0)
  else
  begin
    Items.SyncReadRaw(GetStartTime,GetEndTime,StrToInt(eRequestedValues.Text),cBounded.Checked);
    ShowDataValues(Items[0]);
    Items.Free;
  end;
end;

procedure TForm1.ReadProcessed(Items : TdOPCHdaItems);
begin
  Items[0].Aggregate  := GetAggregateId;
  if cAsync.Checked then
    Items.AsyncReadProcessed(GetStartTime,GetEndTime,StrToInt(eResampleInterval.Text),0)
  else
  begin
    Items.SyncReadProcessed(GetStartTime,GetEndTime,StrToInt(eResampleInterval.Text));
    ShowDataValues(Items[0]);
    Items.Free;
  end;
end;

procedure TForm1.ReadModified(Items : TdOPCHdaItems);
begin
  if cAsync.Checked then
    Items.AsyncReadModified(GetStartTime,GetEndTime,StrToInt(eMaxValues.Text),0)
  else
  begin
    Items.SyncReadModified(GetStartTime,GetEndTime,StrToInt(eMaxValues.Text));
    ShowDataValues(Items[0]);
    Items.Free;
  end;
end;

procedure TForm1.ReadAtTime(Items : TdOPCHdaItems);
var
  Line : string;
  DateList : TDateTimeList;
  I : integer;
begin
  DateList := TDateTimeList.Create;
  try
    for i := 0 to TimeMemo.Lines.Count-1 do
    begin
      Line := TimeMemo.Lines[i];
      if trim(Line) <> '' then
        DateList.Add(StrToDateTime(Line));
    end;

    if cAsync.Checked then
      Items.AsyncReadAtTime(DateList,0)
    else
    begin
      Items.SyncReadAtTime(DateList);
      ShowDataValues(Items[0]);
      Items.Free;
    end;
  finally
    DateList.Free;
  end;
end;

function TForm1.OPCServerReadComplete(Status: HRESULT;
                                      hdaItems: TdOPCHDAItems; UserData: Cardinal;
                                      EventType: TdOPCHDAEventType): HRESULT;
begin
  StatusMemo.Lines.Add(format('Async Read Status: %d Eventype: %d ',[Status,integer(Eventtype)]));
  ShowDataValues(hdaItems[0]);
  hdaItems.Free;
  result := 0;
end;


procedure TForm1.bShowHistoryClick(Sender: TObject);
var
  Items     : TdOPCHDAItems;
  HDAItem   : string;
begin
  if not CheckServer then exit;
  HDAItem := eItemId.Text;
  if Trim(HDAItem) = '' then
  begin
    ShowMessage('first select HDA item');
    exit;
  end;
  Items := TdOPCHdaItems.Create(OPCServer);
  Items.AddItem(HDAItem);
  Listview1.Items.Clear;
  StatusMemo.Lines.Add('Get history from ' + DateTimetoStr(GetStartTime)+' to '+ DateTimetoStr(GetEndTime));
  case PageReadMethod.ActivePageIndex of
    0 : ReadRaw(Items);
    1 : ReadProcessed(Items);
    2 : ReadModified(Items);
    3 : ReadAtTime(Items);
    else ShowMessage('read method not found');
  end;
end;

procedure TForm1.bSelectItemClick(Sender: TObject);
var
  SItem : string;
begin
  if not CheckServer then exit;
  if not OPCServer.Active then
  begin
    ShowMessage('first connect to OPC HDA server');
    exit;
  end;

  SItem := dOPCHDABrowseItemDlg(OPCServer.Browser, false);
  if SItem <> '' then
  begin
    eItemId.Text := SItem;
    Listview1.Items.Clear;
    LReturnedValues.Caption  := '-';
  end;
end;

procedure TForm1.OPCServerDisconnect(Sender: TObject);
begin
  Clear;
  StatusMemo.Lines.Add('disconnected from server: '+OPCServer.ServerCaption)
end;

procedure TForm1.OPCServerConnect(Sender: TObject);
var
  i : integer;
begin
  Clear;
  StatusMemo.Clear;
  StatusMemo.Lines.Add('connected to server: '+OPCServer.ServerCaption);
  LMaxPossible.Caption := IntToStr(OPCServer.GetState.GroupCount);
  for i := 0 to OPCServer.Aggregates.Count-1 do
    cAggregate.Items.AddObject(OPCServer.Aggregates[i].Name,OPCServer.Aggregates[i]);
  TimeMemo.Clear;
  TimeMemo.Lines.Add(DateTimeToStr(Now))
end;

procedure TForm1.OPCServerServerShutdown(Sender: TObject; Reason: String);
begin
  StatusMemo.Lines.Add('shutdown from: '+OPCServer.ServerCaption)
end;


procedure TForm1.SetTime(min: integer);
var
  T   : TDateTime;
  Obj : TDateTimePicker;
begin
 Obj := nil;
 if GetFocus = eFromTime.Handle then
   Obj := eFromTime;
 if GetFocus = eToTime.Handle then
   Obj := eToTime;

 if Obj = nil then
   exit;

 if Min = 0 then
   T := Time
 else
   T := Obj.Time;

 Obj.Time := T + ((min * 60 ) /SecsPerDay);
end;


procedure TForm1.Now1Click(Sender: TObject);
begin
  SetTime(0);
end;

procedure TForm1.Now30min1Click(Sender: TObject);
begin
  SetTime(30);
end;

procedure TForm1.Now60min1Click(Sender: TObject);
begin
  SetTime(60);
end;

procedure TForm1.SetTimeEdit(DObj,TObj : TDateTimePicker; index :integer);
var
  StrTime : string;
  D : TDateTime;
begin
  if Index < 0 then
    exit;
  StrTime := ListView1.Items[Index].Caption;  // first item (Start time)
  D := StrToDateTime(StrTime);
  DObj.Date := trunc(D);
  TObj.Time := D-eFromDate.Date;
end;

procedure TForm1.SetStartEndtime1Click(Sender: TObject);
begin
  if ListView1.Items.Count >= 2 then // if we have min. two items
  begin
    SetTimeEdit(eFromDate,eFromTime,0);
    SetTimeEdit(eToDate,eToTime,ListView1.Items.Count-1);
  end;
end;


// ItemIndex not supported by Delphi 5
function TForm1.ListItemIndex: Integer;
begin
  Result := -1;
  if ListView1.Selected <> nil then
    Result := ListView1.Selected.Index;
end;


procedure TForm1.Starttimefromselected1Click(Sender: TObject);
begin
  if ListItemIndex >= 0 then
      SetTimeEdit(eFromDate,eFromTime,ListItemIndex);
end;

procedure TForm1.Endtimefromselected1Click(Sender: TObject);
begin
  if ListItemIndex >= 0 then
      SetTimeEdit(eToDate,eToTime,ListItemIndex);
end;



procedure TForm1.CopyTimeStamptoClipboard1Click(Sender: TObject);
begin
  if ListItemIndex >= 0 then
    ClipBoard.AsText := ListView1.Items[ListItemIndex].Caption;
end;


procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.SelectServer1Click(Sender: TObject);
begin
 if dOPCSelectHDAServerDlg(OPCServer) then
   OPCServer.Active := true;
end;

function TForm1.CheckServer: boolean;
begin
  result := false;
  if trim(OPCServer.Servername) = '' then
    ShowMessage('first connect to server')
  else
    result := true;
end;

procedure TForm1.Connect1Click(Sender: TObject);
begin
  if CheckServer then
    OPCServer.Active := true;
end;

procedure TForm1.Disconnect1Click(Sender: TObject);
begin
 OPCServer.Active := false;
end;



procedure TForm1.ServerStatus1Click(Sender: TObject);
begin
  if CheckServer then
    dOPCShowServerStatus(OPCServer);
end;

procedure TForm1.EnableDates(enable: boolean);
begin
  eFromDate.Enabled := enable;
  eToDate.Enabled   := enable;
  eFromTime.Enabled := enable;
  eToTime.Enabled   := enable;
end;


procedure TForm1.TabSheet4Show(Sender: TObject);
begin
  EnableDates(false);
end;

procedure TForm1.TabSheet4Hide(Sender: TObject);
begin
  EnableDates(true);
end;

procedure TForm1.ServerInterfaces1Click(Sender: TObject);
begin
  if CheckServer then
    ShowHDAInterfaces(OPCServer);
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  MessageBox(Handle,'dOPC Classic HDA Client Version 1.1 beta'+LF+
                    'This program is freeware.'+LF+
                    'Developed with dOPC Client Toolkit for Delphi version '+dOPCVersion+LF
                     +LF+
                    '(c) 2002-2020 Kassl GmbH (http://www.kassl.de)'+LF+
                    ''+LF+
                    'THIS SOFTWARE IS DISTRIBUTED "AS IS" AND WITHOUT'+LF+
                    'WARRANTIES AS TO PERFORMANCE OF MERCHANTABILITY '+LF+
                    'OR ANY OTHER WARRANTIES WHETHER EXPRESSED'+LF+
                    'OR IMPLIED. YOU USE IT AT YOUR OWN RISK. '+LF+
                    'THE AUTHOR WILL NOT BE LIABLE FOR DATA LOSS,'+LF+
                    'DAMAGES,  LOSS OF PROFITS OR ANY OTHER KIND OF'+LF+
                    'LOSS WHILE USING OR MISUSING THIS SOFTWARE.'+LF+
                    LF+
                    'The source code of this program is included in our'+LF+
                    'dOPC Client Toolkit for Delphi version '+dOPCVersion+LF
                    ,'About',
                    MB_OK or MB_ICONINFORMATION);
end;


end.
